DROP TABLE IF EXISTS uh_user;
DROP TABLE IF EXISTS uh_group;
DROP TABLE IF EXISTS uh_url;
DROP TABLE IF EXISTS uh_url_group_ref;
DROP TABLE IF EXISTS uh_history;
DROP TABLE IF EXISTS uh_attr_user;
DROP TABLE IF EXISTS uh_attr_group;
DROP TABLE IF EXISTS uh_attr_url;

CREATE TABLE uh_user (
  user_id bigint NOT NULL,
  user_profile_ref varchar(255) NOT NULL,
  PRIMARY KEY (user_id)
);

CREATE TABLE uh_group (
  group_id bigint NOT NULL,
  name varchar(255) NOT NULL,
  black_list_type tinyint NOT NULL,
  expire_type tinyint NOT NULL,
  user_id_ref bigint NOT NULL,
  parent_group_id_ref bigint,
  PRIMARY KEY (group_id)
);

CREATE TABLE uh_url (
  url_id bigint NOT NULL,
  name varchar(255) NOT NULL,
  url varchar(255) NOT NULL,
  personal_rating bigint NOT NULL,
  black_list_type tinyint NOT NULL,
  expire_type tinyint NOT NULL,
  user_id_ref bigint NOT NULL,
  PRIMARY KEY (url_id)
);

CREATE TABLE uh_url_group_ref (
  url_id_ref bigint NOT NULL,
  group_id_ref bigint NOT NULL
);

CREATE TABLE uh_history (
  url_id_ref bigint NOT NULL,
  visitation_date datetime NOT NULL
);

CREATE TABLE uh_attr_user (
  user_id_ref bigint NOT NULL,
  name varchar(255) NOT NULL,
  value varchar(255) NOT NULL
);

CREATE TABLE uh_attr_group (
  group_id_ref bigint NOT NULL,
  name varchar(255) NOT NULL,
  value varchar(255) NOT NULL
);

CREATE TABLE uh_attr_url (
  url_id_ref bigint NOT NULL,
  name varchar(255) NOT NULL,
  value varchar(255) NOT NULL
);

-- If we make sure that the ids used for the 3 object types
-- are unique (currently they are because a single ID Generator 
-- sequence is used to generate ids for all 3) then we can use
-- a single attribute table instead of 3.
--
-- However, this affects future changes such as using autoincrementing
-- fields instead of the ID Generator, so for now, 3 tables are being
-- used.

-- CREATE TABLE uh_attr (
--   object_id_ref bigint NOT NULL,
--   name varchar(255) NOT NULL,
--   value varchar(255) NOT NULL
-- );
