package com.topcoder.web.urlhistory;

import com.topcoder.util.errorhandling.BaseException;

/**
 * Exception used to signal configuration related problems.
 *
 * It is used to wrap any exceptions related to the configuration data or that
 * indicate a problem with the configuration file: configuration manager
 * exceptions indicating bad or missing file, reflection exceptions indicating
 * bad class data.
 *
 * Please see the sample configuration file to see details.
 *
 * The message passed in the constructor should be something meaningful to
 * help the user to find the problem. In adition to the message, the actual
 * exception is passed to the user.
 */
public class ConfigurationException extends BaseException {

    /**
     * Constructor.
     *
     * The message is enforced to be completed, so that the user will benefit from meaningful messages.
     *
     * @param message the message describing the exception
     *
     * @throws NullPointerException if the message is null
     */
    public ConfigurationException(String message) throws NullPointerException {
    }

    /**
     * Constructor.
     *
     * The message is enforced to be completed, so that the user will benefit from meaningful messages.
     *
     * @param message the message describing the exception
     * @param cause the cause of the exception
     *
     * @throws NullPointerException if the message is null or if cause is null
     */
    public ConfigurationException(String message, Throwable cause) throws NullPointerException {
    }

}
