package com.topcoder.web.urlhistory;

import com.topcoder.util.errorhandling.BaseException;

/**
 * Exception used to signal requests with invalid data from the user.
 * 
 * Invalid data means for example trying to create an object that is
 * already persisted (attempting to call create twice on the same
 * object). It may also mean trying to use a group as parent from to another
 * group or URL when they belong to different users. 
 *
 * The message passed in the constructor should be something meaningful to
 * help the user to find the problem.
 */
public class InvalidDataException extends BaseException {

    /**
     * Constructor.
     *
     * The message is enforced to be completed, so that the user will benefit from meaningful messages.
     *
     * @param message the message describing the exception
     *
     * @throws NullPointerException if the message is null
     */
    public InvalidDataException(String message) throws NullPointerException {
    }

}
