package com.topcoder.web.urlhistory.compare;

import java.util.Set;

/**
 * CompareStrategy implementation that uses full URL text comparison
 * as criteria.
 */
public class FullTextComparator implements CompareStrategy {
    
    /**
     * Is the comparison case sensitive?
     */
    private boolean caseSensitive = false;
    
    /** 
     * Constructor.
     *
     * @param caseSensitive case sensitive comparison?
     */
    public FullTextComparator(boolean caseSensitive) {        
    }
    
    /** 
     * Returns whether the comparison is case sensitive.
     *
     * @return whether the comparison is case sensitive
     */
    public boolean isCaseSensitive() {
        return false;
    }
    
    /**
     * The areEqual method returns whether the two URL strings are equal.
     * This method compares the two strings directly.
     * Case sensitivity is indicated by the caseSensitive attribute.
     *
     * @param url1 the first URL string
     * @param url2 the second URL string
     * 
     * @return whether the URLs are equal
     * 
     * @throws NullPointerException if any of the arguments is null
     */
    public boolean areEqual(String url1, String url2) throws NullPointerException {
        return false;
    }
    
    /**
     * Returns a substring from the URL that can be used as key for duplicate
     * detection as described in the interface documentation.
     * 
     * In this case it returns the full URL. If the comparison is not
     * case sensitive, the key is converted to lower case.
     *
     * @param url the URL
     * @return a substring from the URL that can be used as key for duplicate
     * detection
     * @throws NullPointerException if the argument is null
     */
    public String getCompareKey(String url) throws NullPointerException {
        return null;
    }
    
    /**
     * Gets the common substring of a given set of URLs that can be used for
     * statistics / reporting purposes.
     * 
     * This comparator returns any of the URLs (converted to lower case) if all
     * URLs are equal and case sensitivity is off. It returns any of the URLs
     * if case sensitivity is on and all URLs are equals. Otherwise it returns
     * the empty string. 
     *
     * @param urls the set of URLs (strings)
     * 
     * @return the common substring
     * 
     * @throws NullPointerException if the argument is null
     * @throws IllegalArgumentException if the set contains something else
     * than Strings (including nulls)
     */
    public String getCommonPart(Set urls) throws NullPointerException, IllegalArgumentException {
        return null;
    }

}
