package com.topcoder.web.urlhistory.compare;

import java.util.Set;

/**
 * CompareStrategy implementation that uses the IP address of the
 * URL as criteria.
 * 
 * The IP address of the host is obtained using 
 * InetAddress.getByName(hostName).getHostAddress().
 * 
 * The hostName is extracted from the URL. One way is to
 * use the java.net.URL class but it is simple enough to
 * do without it. The host name begins after the first occurence
 * of the :// string and last until the : or / characters.
 */
public class IPAddressComparator implements CompareStrategy {
    
    /**
     * The areEqual method returns whether the two URL strings are equal.
     * This method compares the IPs of the two URLs obtained as indicated
     * in the class documentation.
     *
     * @param url1 the first URL string
     * @param url2 the second URL string
     * 
     * @return whether the URLs are equal
     * 
     * @throws NullPointerException if any of the arguments is null
     */
    public boolean areEqual(String url1, String url2) throws NullPointerException {
        return false;
    }
    
    /**
     * Returns a substring from the URL that can be used as key for duplicate
     * detection as described in the interface documentation.
     * 
     * This method returns the IP of the URL obtained as indicated in the class 
     * documentation.
     *
     * @param url the URL
     * @return a substring from the URL that can be used as key for duplicate
     * detection
     * @throws NullPointerException if the argument is null
     */
    public String getCompareKey(String url) throws NullPointerException {
        return null;
    }
    
    /**
     * Gets the common substring of a given set of URLs that can be used for
     * statistics / reporting purposes.
     * 
     * This method determines the IP addresses of all the URLs as indicated
     * in the class documentation. If all IPs are equal, the common value
     * is returned, otherwise the empty string is returned.
     *
     * @param urls the set of URLs (strings)
     * 
     * @return the common substring
     * 
     * @throws NullPointerException if the argument is null
     * @throws IllegalArgumentException if the set contains something else
     * than Strings (including nulls)
     */
    public String getCommonPart(Set urls) throws NullPointerException, IllegalArgumentException {
        return null;
    }

}
