package com.topcoder.web.urlhistory.persistence;

import com.topcoder.util.errorhandling.BaseException;

/**
 * The PersistenceException exception is used to wrap any persistence 
 * implementation specific exception (such as SQL exception or XML exception).
 * These exceptions are thrown by the Persistence interface implementations.
 * Since they are implementation specific, there needs to be a common way
 * to report them to the user, and that's what this exception is used for.
 * 
 * This exception is originally thrown in the persistence implementations.
 * The business logic layer (the manager classes) will forward them to the
 * user.
 */
public class PersistenceException extends BaseException {

    /**
     * Constructor.
     *
     * The message is enforced to be completed, so that the user will benefit 
     * from meaningful messages.
     *
     * @param message the message describing the exception
     *
     * @throws NullPointerException if the message is null
     */
    public PersistenceException(String message) throws NullPointerException {
    }

    /**
     * Constructor.
     *
     * The message is enforced to be completed, so that the user will benefit 
     * from meaningful messages.
     *
     * @param message the message describing the exception
     * @param cause the cause of the exception
     *
     * @throws NullPointerException if the message is null or if cause is null
     */
    public PersistenceException(String message, Throwable cause) throws NullPointerException {
    }
    
}
