package com.topcoder.web.urlhistory.sort;

import java.util.Comparator;

/**
 * Comparator that is used to sort group or URL statistics by last visit date.
 * This comparator accepts two CommonStatistics objects and compares
 * the Dates returned by getLastVisit().
 */
public class LastVisitSort implements Comparator {

    /**
     * This method expects to receive two CommonStatistics objects.
     * It compares the Dates returned by getLastVisit() and returns the
     * result.
     * 
     * @param o1 the first CommonStatistics instance
     * @param o2 the second CommonStatistics instance
     * 
     * @return a negative integer, zero, or a positive integer as the
     * first argument is less than, equal to, or greater than the second. 
     * 
     * @throws ClassCastException if either argument is not a CommonStatistics
     * instance or is null
     */
    public int compare(Object o1, Object o2) throws ClassCastException {
        return 0;
    }

}
