package com.topcoder.web.urlhistory.sort;

import java.util.Comparator;

/**
 * This is a special type of comparator that wraps another comparator
 * and simply reverses (negates) the result from the another comparator.
 * The result is that the sort becomes descending instead of ascending.
 */
public class ReverseSort implements Comparator {
    
    /**
     * The wrapped comparator. Set in the constructor.
     */
    private Comparator comparator = null;
    
    /**
     * Constructor.
     *
     * @param comparator the wrapped comparator
     * 
     * @throws NullPointerException if the argument is null
     */
    public ReverseSort(Comparator comparator) throws NullPointerException {        
    }

    /**
     * This method simply calls the compare method of the wrapped comparator
     * and returns the negated result.
     * 
     * @param o1 the first object
     * @param o2 the second object
     * 
     * @return a negative integer, zero, or a positive integer as the
     * first argument is greater than, equal to, or less than the second,
     * the negation of the result returned by a normal comparator       
     */
    public int compare(Object o1, Object o2) {
        return 0;
    }

}
