package com.topcoder.web.urlhistory.sort;

import java.util.Comparator;

/**
 * Comparator that is used to sort URL statistics by URL text.
 * This comparator accepts two URLStatistics objects and compares
 * the Strings returned by getURL().
 */
public class URLTextSort implements Comparator {

    /**
     * This method expects to receive two URLStatistics objects.
     * It compares the Strings returned by getURL() and returns the
     * result.
     * 
     * @param o1 the first URLStatistics instance
     * @param o2 the second URLStatistics instance
     * 
     * @return a negative integer, zero, or a positive integer as the
     * first argument is less than, equal to, or greater than the second. 
     * 
     * @throws ClassCastException if either argument is not a URLStatistics
     * instance or is null
     */
    public int compare(Object o1, Object o2) throws ClassCastException {
        return 0;
    }

}
